#!/usr/bin/env python

import unittest
#from math import sqrt

from Numeric import allclose, array, transpose, arange, ones, Float

from cg_solve import *

from scipy import sparse
        
class TestCase(unittest.TestCase):

    def setUp(self):
        pass
        
    def tearDown(self):
        pass


    def test_solve(self):
        A = [[2.0, -1.0, 0.0, 0.0 ],
             [-1.0, 2.0, -1.0, 0.0],
             [0.0, -1.0, 2.0, -1.0],
             [0.0,0.0, -1.0, 2.0]]
        
        A = sparse.dok_matrix(A)

        print "A"
        print A
        
        xe = [0.0, 1.0, 2.0, 3.0]
        b  = A*xe
        x =  [0.0, 0.0, 0.0, 0.0]

        x = conjugate_gradient(A,b,x,iprint=1)

        print "x",x

        assert allclose(x,xe)


    def test_solve_large(self):
        A = sparse.dok_matrix()

        n = 50
        for i in arange(0,n):
            A[i,i] = 1.0
            if i > 0 :
                A[i,i-1] = -0.5
            if i < n-1 :
                A[i,i+1] = -0.5
                
#        print "\n"
#        print "A\n"
#        print A
        
        
        xe = ones( (n,), Float)

#        print xe
        b  = A*xe

        x = conjugate_gradient(A,b,b,tol=1.0e-5,iprint=10)

#        print "x",x

        assert allclose(x,xe)

    def test_solve_large_2d(self):
        A = sparse.dok_matrix()

        n = 30
        m = 30
        for i in arange(0,n):
            for j in arange(0,m):
                I = j+m*i
                A[I,I] = 4.0
                if i > 0  :
                    A[I,I-m] = -1.0
                if i < n-1 :
                    A[I,I+m] = -1.0
                if j > 0  :
                    A[I,I-1] = -1.0
                if j < m-1 :
                    A[I,I+1] = -1.0
                
#        print "\n"
#        print "A\n"
#        print A.todense()
        
        
        xe = ones( (n*m,), Float)

#        print xe
        b  = A*xe

        x = conjugate_gradient(A,b,b,iprint=10)

#        print "x",x

        assert allclose(x,xe)

        
#-------------------------------------------------------------
if __name__ == "__main__":
    suite = unittest.makeSuite(TestCase,'test')
    runner = unittest.TextTestRunner()
    runner.run(suite)

    
    



